/* Battery.c generated by valac 0.56.8, the Vala compiler
 * generated from Battery.vala, do not modify */

/*
 * Copyright (c) 2011-2016 elementary LLC. (https://launchpad.net/switchboard-plug-power)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#include "power.h"
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define POWER_TYPE_UPOWER (power_upower_get_type ())
#define POWER_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER, PowerUpower))
#define POWER_IS_UPOWER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER))
#define POWER_UPOWER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER, PowerUpowerIface))

typedef struct _PowerUpower PowerUpower;
typedef struct _PowerUpowerIface PowerUpowerIface;

#define POWER_TYPE_UPOWER_PROXY (power_upower_proxy_get_type ())

#define POWER_TYPE_UPOWER_DEVICE (power_upower_device_get_type ())
#define POWER_UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_TYPE_UPOWER_DEVICE, PowerUpowerDevice))
#define POWER_IS_UPOWER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_TYPE_UPOWER_DEVICE))
#define POWER_UPOWER_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), POWER_TYPE_UPOWER_DEVICE, PowerUpowerDeviceIface))

typedef struct _PowerUpowerDevice PowerUpowerDevice;
typedef struct _PowerUpowerDeviceIface PowerUpowerDeviceIface;

#define POWER_TYPE_UPOWER_DEVICE_PROXY (power_upower_device_proxy_get_type ())
enum  {
	POWER_BATTERY_0_PROPERTY,
	POWER_BATTERY_NUM_PROPERTIES
};
static GParamSpec* power_battery_properties[POWER_BATTERY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerUpowerIface {
	GTypeInterface parent_iface;
	char** (*enumerate_devices) (PowerUpower* self, gint* result_length1, GError** error);
	gboolean (*get_on_battery) (PowerUpower* self);
	gboolean (*get_low_on_battery) (PowerUpower* self);
};

struct _PowerUpowerDeviceIface {
	GTypeInterface parent_iface;
	void (*refresh) (PowerUpowerDevice* self, GError** error);
	gboolean (*get_online) (PowerUpowerDevice* self);
	gboolean (*get_power_supply) (PowerUpowerDevice* self);
	gboolean (*get_is_present) (PowerUpowerDevice* self);
	guint (*get_device_type) (PowerUpowerDevice* self);
};

struct _PowerBatteryPrivate {
	PowerUpower* upower;
	PowerUpowerDevice* upower_device;
	gchar* dbus_upower_battery_path;
};

static gint PowerBattery_private_offset;
static gpointer power_battery_parent_class = NULL;

VALA_EXTERN GType power_upower_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_register_object (void* object,
                                    GDBusConnection* connection,
                                    const gchar* path,
                                    GError** error);
VALA_EXTERN GType power_upower_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType power_upower_device_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint power_upower_device_register_object (void* object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error);
VALA_EXTERN GType power_upower_device_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gboolean power_upower_get_on_battery (PowerUpower* self);
VALA_EXTERN gboolean power_upower_device_get_is_present (PowerUpowerDevice* self);
static gchar* power_battery_get_dbus_path (PowerBattery* self,
                                    PowerUpower* upow);
VALA_EXTERN char** power_upower_enumerate_devices (PowerUpower* self,
                                       gint* result_length1,
                                       GError** error);
VALA_EXTERN guint power_upower_device_get_device_type (PowerUpowerDevice* self);
static GObject * power_battery_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void power_battery_finalize (GObject * obj);
static GType power_battery_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_battery_get_instance_private (PowerBattery* self)
{
	return G_STRUCT_MEMBER_P (self, PowerBattery_private_offset);
}

gboolean
power_battery_is_present (PowerBattery* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	PowerUpower* _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp2_ = self->priv->upower;
	if (_tmp2_ != NULL) {
		PowerUpower* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->upower;
		_tmp4_ = power_upower_get_on_battery (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp1_ = _tmp5_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		PowerUpowerDevice* _tmp7_;
		_tmp7_ = self->priv->upower_device;
		if (_tmp7_ != NULL) {
			PowerUpowerDevice* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp8_ = self->priv->upower_device;
			_tmp9_ = power_upower_device_get_is_present (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp6_ = _tmp10_;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp0_ = _tmp6_;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gchar*
power_battery_get_dbus_path (PowerBattery* self,
                             PowerUpower* upow)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (upow != NULL, NULL);
	_tmp0_ = g_strdup ("");
	path = _tmp0_;
	{
		char** devs = NULL;
		gint _tmp1_ = 0;
		char** _tmp2_;
		gint devs_length1;
		gint _devs_size_;
		_tmp2_ = power_upower_enumerate_devices (upow, &_tmp1_, &_inner_error0_);
		devs = _tmp2_;
		devs_length1 = _tmp1_;
		_devs_size_ = devs_length1;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp3_ = FALSE;
				_tmp3_ = TRUE;
				while (TRUE) {
					char** _tmp5_;
					gint _tmp5__length1;
					PowerUpowerDevice* device = NULL;
					char** _tmp6_;
					gint _tmp6__length1;
					const char* _tmp7_;
					const gchar* _tmp8_;
					PowerUpowerDevice* _tmp9_;
					PowerUpowerDevice* _tmp10_;
					guint _tmp11_;
					guint _tmp12_;
					if (!_tmp3_) {
						gint _tmp4_;
						_tmp4_ = i;
						i = _tmp4_ + 1;
					}
					_tmp3_ = FALSE;
					_tmp5_ = devs;
					_tmp5__length1 = devs_length1;
					if (!(i < _tmp5__length1)) {
						break;
					}
					_tmp6_ = devs;
					_tmp6__length1 = devs_length1;
					_tmp7_ = _tmp6_[i];
					_tmp8_ = string_to_string ((const gchar*) _tmp7_);
					_tmp9_ = (PowerUpowerDevice*) g_initable_new (POWER_TYPE_UPOWER_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp8_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
					device = (PowerUpowerDevice*) _tmp9_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
						goto __catch0_g_error;
					}
					_tmp10_ = device;
					_tmp11_ = power_upower_device_get_device_type (_tmp10_);
					_tmp12_ = _tmp11_;
					if (_tmp12_ == ((guint) 2)) {
						char** _tmp13_;
						gint _tmp13__length1;
						const char* _tmp14_;
						const gchar* _tmp15_;
						gchar* _tmp16_;
						_tmp13_ = devs;
						_tmp13__length1 = devs_length1;
						_tmp14_ = _tmp13_[i];
						_tmp15_ = string_to_string ((const gchar*) _tmp14_);
						_tmp16_ = g_strdup (_tmp15_);
						_g_free0 (path);
						path = _tmp16_;
						_g_object_unref0 (device);
						break;
					}
					_g_object_unref0 (device);
				}
			}
		}
		devs = (_vala_array_free (devs, devs_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_critical ("Battery.vala:62: acpi couldn't get upower devices");
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = path;
	return result;
}

PowerBattery*
power_battery_construct (GType object_type)
{
	PowerBattery * self = NULL;
	self = (PowerBattery*) g_object_new (object_type, NULL);
	return self;
}

PowerBattery*
power_battery_new (void)
{
	return power_battery_construct (POWER_TYPE_BATTERY);
}

static GObject *
power_battery_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerBattery * self;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (power_battery_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_BATTERY, PowerBattery);
	{
		PowerUpower* _tmp0_ = NULL;
		PowerUpower* _tmp1_;
		PowerUpower* _tmp2_;
		PowerUpower* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		const gchar* _tmp6_;
		_tmp1_ = (PowerUpower*) g_initable_new (POWER_TYPE_UPOWER_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_DBUS_UPOWER_PATH, "g-interface-name", "org.freedesktop.UPower", NULL);
		_tmp0_ = (PowerUpower*) _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (self->priv->upower);
		self->priv->upower = _tmp2_;
		_tmp3_ = self->priv->upower;
		_tmp4_ = power_battery_get_dbus_path (self, _tmp3_);
		_g_free0 (self->priv->dbus_upower_battery_path);
		self->priv->dbus_upower_battery_path = _tmp4_;
		_tmp6_ = self->priv->dbus_upower_battery_path;
		if (g_strcmp0 (_tmp6_, "") != 0) {
			const gchar* _tmp7_;
			_tmp7_ = self->priv->dbus_upower_battery_path;
			_tmp5_ = _tmp7_ != NULL;
		} else {
			_tmp5_ = FALSE;
		}
		if (_tmp5_) {
			PowerUpowerDevice* _tmp8_ = NULL;
			const gchar* _tmp9_;
			PowerUpowerDevice* _tmp10_;
			PowerUpowerDevice* _tmp11_;
			const gchar* _tmp12_;
			_tmp9_ = self->priv->dbus_upower_battery_path;
			_tmp10_ = (PowerUpowerDevice*) g_initable_new (POWER_TYPE_UPOWER_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", POWER_DBUS_UPOWER_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", _tmp9_, "g-interface-name", "org.freedesktop.UPower.Device", NULL);
			_tmp8_ = (PowerUpowerDevice*) _tmp10_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (_tmp0_);
				goto __catch0_g_error;
			}
			_tmp11_ = _tmp8_;
			_tmp8_ = NULL;
			_g_object_unref0 (self->priv->upower_device);
			self->priv->upower_device = _tmp11_;
			g_debug ("Battery.vala:33: Connection to UPower bus established");
			_tmp12_ = self->priv->dbus_upower_battery_path;
			g_debug ("Battery.vala:34: Battery detected at path: %s", _tmp12_);
			_g_object_unref0 (_tmp8_);
		}
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_critical ("Battery.vala:37: Connecting to UPower bus failed: %s", _tmp14_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	return obj;
}

static void
power_battery_class_init (PowerBatteryClass * klass,
                          gpointer klass_data)
{
	power_battery_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PowerBattery_private_offset);
	G_OBJECT_CLASS (klass)->constructor = power_battery_constructor;
	G_OBJECT_CLASS (klass)->finalize = power_battery_finalize;
}

static void
power_battery_instance_init (PowerBattery * self,
                             gpointer klass)
{
	self->priv = power_battery_get_instance_private (self);
}

static void
power_battery_finalize (GObject * obj)
{
	PowerBattery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_BATTERY, PowerBattery);
	_g_object_unref0 (self->priv->upower);
	_g_object_unref0 (self->priv->upower_device);
	_g_free0 (self->priv->dbus_upower_battery_path);
	G_OBJECT_CLASS (power_battery_parent_class)->finalize (obj);
}

static GType
power_battery_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerBatteryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_battery_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerBattery), 0, (GInstanceInitFunc) power_battery_instance_init, NULL };
	GType power_battery_type_id;
	power_battery_type_id = g_type_register_static (G_TYPE_OBJECT, "PowerBattery", &g_define_type_info, 0);
	PowerBattery_private_offset = g_type_add_instance_private (power_battery_type_id, sizeof (PowerBatteryPrivate));
	return power_battery_type_id;
}

GType
power_battery_get_type (void)
{
	static volatile gsize power_battery_type_id__once = 0;
	if (g_once_init_enter (&power_battery_type_id__once)) {
		GType power_battery_type_id;
		power_battery_type_id = power_battery_get_type_once ();
		g_once_init_leave (&power_battery_type_id__once, power_battery_type_id);
	}
	return power_battery_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

