/* PowerModeButton.c generated by valac 0.56.8, the Vala compiler
 * generated from PowerModeButton.vala, do not modify */

/*
 * Copyright 2021-2022 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *
 * Authored by: Subhadeep Jasu <subhajasu@gmail.com>
 */

#include "power.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

enum  {
	POWER_POWER_MODE_BUTTON_0_PROPERTY,
	POWER_POWER_MODE_BUTTON_PPROFILE_PROPERTY,
	POWER_POWER_MODE_BUTTON_NUM_PROPERTIES
};
static GParamSpec* power_power_mode_button_properties[POWER_POWER_MODE_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PowerPowerModeButtonPrivate {
	PowerPowerProfile* _pprofile;
	GtkRadioButton* saver_radio;
	GtkRadioButton* balanced_radio;
	GtkRadioButton* performance_radio;
};

static gint PowerPowerModeButton_private_offset;
static gpointer power_power_mode_button_parent_class = NULL;

static void power_power_mode_button_update_active_profile (PowerPowerModeButton* self);
static void power_power_mode_button_set_pprofile (PowerPowerModeButton* self,
                                           PowerPowerProfile* value);
static GObject * power_power_mode_button_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _power_power_mode_button_update_active_profile_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                                       GVariant* changed_properties,
                                                                                       gchar** invalidated_properties,
                                                                                       gpointer self);
static void _power_power_mode_button___lambda5_ (PowerPowerModeButton* self);
static void __power_power_mode_button___lambda5__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void _power_power_mode_button___lambda6_ (PowerPowerModeButton* self);
static void __power_power_mode_button___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void _power_power_mode_button___lambda7_ (PowerPowerModeButton* self);
static void __power_power_mode_button___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void power_power_mode_button_finalize (GObject * obj);
static GType power_power_mode_button_get_type_once (void);
static void _vala_power_power_mode_button_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_power_power_mode_button_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
power_power_mode_button_get_instance_private (PowerPowerModeButton* self)
{
	return G_STRUCT_MEMBER_P (self, PowerPowerModeButton_private_offset);
}

static void
power_power_mode_button_update_active_profile (PowerPowerModeButton* self)
{
	PowerPowerProfile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
	static GQuark _tmp4_label0 = 0;
	static GQuark _tmp4_label1 = 0;
	static GQuark _tmp4_label2 = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pprofile;
	_tmp1_ = power_power_profile_get_active_profile (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
	g_free (_tmp3_);
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("power-saver")))) {
		switch (0) {
			default:
			{
				GtkRadioButton* _tmp6_;
				_tmp6_ = self->priv->saver_radio;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp6_, TRUE);
				break;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("balanced")))) {
		switch (0) {
			default:
			{
				GtkRadioButton* _tmp7_;
				_tmp7_ = self->priv->balanced_radio;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, TRUE);
				break;
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("performance")))) {
		switch (0) {
			default:
			{
				GtkRadioButton* _tmp8_;
				_tmp8_ = self->priv->performance_radio;
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp8_, TRUE);
				break;
			}
		}
	}
}

PowerPowerModeButton*
power_power_mode_button_construct (GType object_type)
{
	PowerPowerModeButton * self = NULL;
	self = (PowerPowerModeButton*) g_object_new (object_type, NULL);
	return self;
}

PowerPowerModeButton*
power_power_mode_button_new (void)
{
	return power_power_mode_button_construct (POWER_TYPE_POWER_MODE_BUTTON);
}

PowerPowerProfile*
power_power_mode_button_get_pprofile (PowerPowerModeButton* self)
{
	PowerPowerProfile* result;
	PowerPowerProfile* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pprofile;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
power_power_mode_button_set_pprofile (PowerPowerModeButton* self,
                                      PowerPowerProfile* value)
{
	PowerPowerProfile* old_value;
	g_return_if_fail (self != NULL);
	old_value = power_power_mode_button_get_pprofile (self);
	if (old_value != value) {
		PowerPowerProfile* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_pprofile);
		self->priv->_pprofile = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, power_power_mode_button_properties[POWER_POWER_MODE_BUTTON_PPROFILE_PROPERTY]);
	}
}

static void
_power_power_mode_button_update_active_profile_g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                                  GVariant* changed_properties,
                                                                                  gchar** invalidated_properties,
                                                                                  gpointer self)
{
	power_power_mode_button_update_active_profile ((PowerPowerModeButton*) self);
}

static void
_power_power_mode_button___lambda5_ (PowerPowerModeButton* self)
{
	PowerPowerProfile* _tmp0_;
	_tmp0_ = self->priv->_pprofile;
	power_power_profile_set_active_profile (_tmp0_, "power-saver");
}

static void
__power_power_mode_button___lambda5__gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	_power_power_mode_button___lambda5_ ((PowerPowerModeButton*) self);
}

static void
_power_power_mode_button___lambda6_ (PowerPowerModeButton* self)
{
	PowerPowerProfile* _tmp0_;
	_tmp0_ = self->priv->_pprofile;
	power_power_profile_set_active_profile (_tmp0_, "balanced");
}

static void
__power_power_mode_button___lambda6__gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	_power_power_mode_button___lambda6_ ((PowerPowerModeButton*) self);
}

static void
_power_power_mode_button___lambda7_ (PowerPowerModeButton* self)
{
	PowerPowerProfile* _tmp0_;
	_tmp0_ = self->priv->_pprofile;
	power_power_profile_set_active_profile (_tmp0_, "performance");
}

static void
__power_power_mode_button___lambda7__gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
	_power_power_mode_button___lambda7_ ((PowerPowerModeButton*) self);
}

static GObject *
power_power_mode_button_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PowerPowerModeButton * self;
	GtkImage* saver_icon = NULL;
	GtkImage* _tmp4_;
	GtkLabel* saver_label = NULL;
	GtkLabel* _tmp5_;
	GtkBox* saver_button_box = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkImage* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkRadioButton* _tmp11_;
	GtkRadioButton* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkRadioButton* _tmp14_;
	GtkBox* _tmp15_;
	GtkImage* balanced_icon = NULL;
	GtkImage* _tmp16_;
	GtkLabel* balanced_label = NULL;
	GtkLabel* _tmp17_;
	GtkBox* balanced_button_box = NULL;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkImage* _tmp20_;
	GtkBox* _tmp21_;
	GtkLabel* _tmp22_;
	GtkRadioButton* _tmp23_;
	GtkRadioButton* _tmp24_;
	GtkRadioButton* _tmp25_;
	GtkStyleContext* _tmp26_;
	GtkRadioButton* _tmp27_;
	GtkBox* _tmp28_;
	GtkImage* performance_icon = NULL;
	GtkImage* _tmp29_;
	GtkLabel* performance_label = NULL;
	GtkLabel* _tmp30_;
	GtkBox* performance_button_box = NULL;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	GtkImage* _tmp33_;
	GtkBox* _tmp34_;
	GtkLabel* _tmp35_;
	GtkRadioButton* _tmp36_;
	GtkRadioButton* _tmp37_;
	GtkRadioButton* _tmp38_;
	GtkStyleContext* _tmp39_;
	GtkRadioButton* _tmp40_;
	GtkBox* _tmp41_;
	PowerPowerProfile* _tmp65_;
	GtkRadioButton* _tmp66_;
	GtkRadioButton* _tmp67_;
	GtkRadioButton* _tmp68_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (power_power_mode_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
	{
		PowerPowerProfile* _tmp0_ = NULL;
		PowerPowerProfile* _tmp1_;
		_tmp1_ = (PowerPowerProfile*) g_initable_new (POWER_TYPE_POWER_PROFILE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", POWER_POWER_PROFILES_DAEMON_NAME, "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", POWER_POWER_PROFILES_DAEMON_PATH, "g-interface-name", "net.hadess.PowerProfiles", NULL);
		_tmp0_ = (PowerPowerProfile*) _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		power_power_mode_button_set_pprofile (self, _tmp0_);
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_critical ("PowerModeButton.vala:33: %s", _tmp3_);
		_g_error_free0 (e);
		return obj;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp4_ = (GtkImage*) gtk_image_new_from_resource ("/io/elementary/switchboard/plug/power/32x32/apps/power-mode-powersavin" \
"g.svg");
	g_object_ref_sink (_tmp4_);
	saver_icon = _tmp4_;
	_tmp5_ = (GtkLabel*) gtk_label_new (_ ("Power Saver"));
	g_object_ref_sink (_tmp5_);
	saver_label = _tmp5_;
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 3);
	g_object_ref_sink (_tmp6_);
	saver_button_box = _tmp6_;
	_tmp7_ = saver_button_box;
	_tmp8_ = saver_icon;
	gtk_box_pack_start (_tmp7_, (GtkWidget*) _tmp8_, TRUE, TRUE, (guint) 0);
	_tmp9_ = saver_button_box;
	_tmp10_ = saver_label;
	gtk_box_pack_end (_tmp9_, (GtkWidget*) _tmp10_, TRUE, TRUE, (guint) 0);
	_tmp11_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->saver_radio);
	self->priv->saver_radio = _tmp11_;
	_tmp12_ = self->priv->saver_radio;
	_tmp13_ = gtk_widget_get_style_context ((GtkWidget*) _tmp12_);
	gtk_style_context_add_class (_tmp13_, "image-button");
	_tmp14_ = self->priv->saver_radio;
	_tmp15_ = saver_button_box;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
	_tmp16_ = (GtkImage*) gtk_image_new_from_resource ("/io/elementary/switchboard/plug/power/32x32/apps/power-mode-balanced.s" \
"vg");
	g_object_ref_sink (_tmp16_);
	balanced_icon = _tmp16_;
	_tmp17_ = (GtkLabel*) gtk_label_new (_ ("Balanced"));
	g_object_ref_sink (_tmp17_);
	balanced_label = _tmp17_;
	_tmp18_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 3);
	g_object_ref_sink (_tmp18_);
	balanced_button_box = _tmp18_;
	_tmp19_ = balanced_button_box;
	_tmp20_ = balanced_icon;
	gtk_box_pack_start (_tmp19_, (GtkWidget*) _tmp20_, TRUE, TRUE, (guint) 0);
	_tmp21_ = balanced_button_box;
	_tmp22_ = balanced_label;
	gtk_box_pack_end (_tmp21_, (GtkWidget*) _tmp22_, TRUE, TRUE, (guint) 0);
	_tmp23_ = self->priv->saver_radio;
	_tmp24_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp23_);
	g_object_ref_sink (_tmp24_);
	_g_object_unref0 (self->priv->balanced_radio);
	self->priv->balanced_radio = _tmp24_;
	_tmp25_ = self->priv->balanced_radio;
	_tmp26_ = gtk_widget_get_style_context ((GtkWidget*) _tmp25_);
	gtk_style_context_add_class (_tmp26_, "image-button");
	_tmp27_ = self->priv->balanced_radio;
	_tmp28_ = balanced_button_box;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = (GtkImage*) gtk_image_new_from_resource ("/io/elementary/switchboard/plug/power/32x32/apps/power-mode-performanc" \
"e.svg");
	g_object_ref_sink (_tmp29_);
	performance_icon = _tmp29_;
	_tmp30_ = (GtkLabel*) gtk_label_new (_ ("Performance"));
	g_object_ref_sink (_tmp30_);
	performance_label = _tmp30_;
	_tmp31_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 3);
	g_object_ref_sink (_tmp31_);
	performance_button_box = _tmp31_;
	_tmp32_ = performance_button_box;
	_tmp33_ = performance_icon;
	gtk_box_pack_start (_tmp32_, (GtkWidget*) _tmp33_, TRUE, TRUE, (guint) 0);
	_tmp34_ = performance_button_box;
	_tmp35_ = performance_label;
	gtk_box_pack_end (_tmp34_, (GtkWidget*) _tmp35_, TRUE, TRUE, (guint) 0);
	_tmp36_ = self->priv->saver_radio;
	_tmp37_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp36_);
	g_object_ref_sink (_tmp37_);
	_g_object_unref0 (self->priv->performance_radio);
	self->priv->performance_radio = _tmp37_;
	_tmp38_ = self->priv->performance_radio;
	_tmp39_ = gtk_widget_get_style_context ((GtkWidget*) _tmp38_);
	gtk_style_context_add_class (_tmp39_, "image-button");
	_tmp40_ = self->priv->performance_radio;
	_tmp41_ = performance_button_box;
	gtk_container_add ((GtkContainer*) _tmp40_, (GtkWidget*) _tmp41_);
	gtk_box_set_homogeneous ((GtkBox*) self, TRUE);
	gtk_box_set_spacing ((GtkBox*) self, 6);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp42_ = FALSE;
			_tmp42_ = TRUE;
			while (TRUE) {
				PowerPowerProfile* _tmp44_;
				GHashTable** _tmp45_;
				gint _tmp45__length1;
				gint _tmp46_ = 0;
				GHashTable** _tmp47_;
				gint _tmp47__length1;
				GHashTable** _tmp48_;
				gint _tmp48__length1;
				gboolean _tmp49_;
				PowerPowerProfile* _tmp50_;
				GHashTable** _tmp51_;
				gint _tmp51__length1;
				gint _tmp52_ = 0;
				GHashTable** _tmp53_;
				gint _tmp53__length1;
				GHashTable** _tmp54_;
				gint _tmp54__length1;
				GHashTable* _tmp55_;
				gconstpointer _tmp56_;
				const gchar* _tmp57_;
				const gchar* _tmp58_;
				const gchar* _tmp59_;
				GQuark _tmp61_ = 0U;
				static GQuark _tmp60_label0 = 0;
				static GQuark _tmp60_label1 = 0;
				static GQuark _tmp60_label2 = 0;
				if (!_tmp42_) {
					gint _tmp43_;
					_tmp43_ = i;
					i = _tmp43_ + 1;
				}
				_tmp42_ = FALSE;
				_tmp44_ = self->priv->_pprofile;
				_tmp45_ = power_power_profile_get_profiles (_tmp44_, &_tmp46_);
				_tmp45__length1 = _tmp46_;
				_tmp47_ = _tmp45_;
				_tmp47__length1 = _tmp45__length1;
				_tmp48_ = _tmp47_;
				_tmp48__length1 = _tmp47__length1;
				_tmp49_ = !(i < _tmp47__length1);
				_tmp48_ = (_vala_array_free (_tmp48_, _tmp48__length1, (GDestroyNotify) g_hash_table_unref), NULL);
				if (_tmp49_) {
					break;
				}
				_tmp50_ = self->priv->_pprofile;
				_tmp51_ = power_power_profile_get_profiles (_tmp50_, &_tmp52_);
				_tmp51__length1 = _tmp52_;
				_tmp53_ = _tmp51_;
				_tmp53__length1 = _tmp51__length1;
				_tmp54_ = _tmp53_;
				_tmp54__length1 = _tmp53__length1;
				_tmp55_ = _tmp54_[i];
				_tmp56_ = g_hash_table_lookup (_tmp55_, "Profile");
				_tmp57_ = g_variant_get_string ((GVariant*) _tmp56_, NULL);
				_tmp58_ = _tmp57_;
				_tmp54_ = (_vala_array_free (_tmp54_, _tmp54__length1, (GDestroyNotify) g_hash_table_unref), NULL);
				_tmp59_ = _tmp58_;
				_tmp61_ = (NULL == _tmp59_) ? 0 : g_quark_from_string (_tmp59_);
				if (_tmp61_ == ((0 != _tmp60_label0) ? _tmp60_label0 : (_tmp60_label0 = g_quark_from_static_string ("power-saver")))) {
					switch (0) {
						default:
						{
							GtkRadioButton* _tmp62_;
							_tmp62_ = self->priv->saver_radio;
							gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp62_);
							break;
						}
					}
				} else if (_tmp61_ == ((0 != _tmp60_label1) ? _tmp60_label1 : (_tmp60_label1 = g_quark_from_static_string ("balanced")))) {
					switch (0) {
						default:
						{
							GtkRadioButton* _tmp63_;
							_tmp63_ = self->priv->balanced_radio;
							gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp63_);
							break;
						}
					}
				} else if (_tmp61_ == ((0 != _tmp60_label2) ? _tmp60_label2 : (_tmp60_label2 = g_quark_from_static_string ("performance")))) {
					switch (0) {
						default:
						{
							GtkRadioButton* _tmp64_;
							_tmp64_ = self->priv->performance_radio;
							gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp64_);
							break;
						}
					}
				} else {
					switch (0) {
						default:
						{
							break;
						}
					}
				}
			}
		}
	}
	power_power_mode_button_update_active_profile (self);
	_tmp65_ = self->priv->_pprofile;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) _power_power_mode_button_update_active_profile_g_dbus_proxy_g_properties_changed, self, 0);
	_tmp66_ = self->priv->saver_radio;
	g_signal_connect_object ((GtkButton*) _tmp66_, "clicked", (GCallback) __power_power_mode_button___lambda5__gtk_button_clicked, self, 0);
	_tmp67_ = self->priv->balanced_radio;
	g_signal_connect_object ((GtkButton*) _tmp67_, "clicked", (GCallback) __power_power_mode_button___lambda6__gtk_button_clicked, self, 0);
	_tmp68_ = self->priv->performance_radio;
	g_signal_connect_object ((GtkButton*) _tmp68_, "clicked", (GCallback) __power_power_mode_button___lambda7__gtk_button_clicked, self, 0);
	_g_object_unref0 (performance_button_box);
	_g_object_unref0 (performance_label);
	_g_object_unref0 (performance_icon);
	_g_object_unref0 (balanced_button_box);
	_g_object_unref0 (balanced_label);
	_g_object_unref0 (balanced_icon);
	_g_object_unref0 (saver_button_box);
	_g_object_unref0 (saver_label);
	_g_object_unref0 (saver_icon);
	return obj;
}

static void
power_power_mode_button_class_init (PowerPowerModeButtonClass * klass,
                                    gpointer klass_data)
{
	power_power_mode_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PowerPowerModeButton_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_power_power_mode_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_power_power_mode_button_set_property;
	G_OBJECT_CLASS (klass)->constructor = power_power_mode_button_constructor;
	G_OBJECT_CLASS (klass)->finalize = power_power_mode_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), POWER_POWER_MODE_BUTTON_PPROFILE_PROPERTY, power_power_mode_button_properties[POWER_POWER_MODE_BUTTON_PPROFILE_PROPERTY] = g_param_spec_object ("pprofile", "pprofile", "pprofile", POWER_TYPE_POWER_PROFILE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
power_power_mode_button_instance_init (PowerPowerModeButton * self,
                                       gpointer klass)
{
	self->priv = power_power_mode_button_get_instance_private (self);
	self->priv->_pprofile = NULL;
}

static void
power_power_mode_button_finalize (GObject * obj)
{
	PowerPowerModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
	_g_object_unref0 (self->priv->_pprofile);
	_g_object_unref0 (self->priv->saver_radio);
	_g_object_unref0 (self->priv->balanced_radio);
	_g_object_unref0 (self->priv->performance_radio);
	G_OBJECT_CLASS (power_power_mode_button_parent_class)->finalize (obj);
}

static GType
power_power_mode_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PowerPowerModeButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) power_power_mode_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PowerPowerModeButton), 0, (GInstanceInitFunc) power_power_mode_button_instance_init, NULL };
	GType power_power_mode_button_type_id;
	power_power_mode_button_type_id = g_type_register_static (gtk_box_get_type (), "PowerPowerModeButton", &g_define_type_info, 0);
	PowerPowerModeButton_private_offset = g_type_add_instance_private (power_power_mode_button_type_id, sizeof (PowerPowerModeButtonPrivate));
	return power_power_mode_button_type_id;
}

GType
power_power_mode_button_get_type (void)
{
	static volatile gsize power_power_mode_button_type_id__once = 0;
	if (g_once_init_enter (&power_power_mode_button_type_id__once)) {
		GType power_power_mode_button_type_id;
		power_power_mode_button_type_id = power_power_mode_button_get_type_once ();
		g_once_init_leave (&power_power_mode_button_type_id__once, power_power_mode_button_type_id);
	}
	return power_power_mode_button_type_id__once;
}

static void
_vala_power_power_mode_button_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	PowerPowerModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
	switch (property_id) {
		case POWER_POWER_MODE_BUTTON_PPROFILE_PROPERTY:
		g_value_set_object (value, power_power_mode_button_get_pprofile (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_power_power_mode_button_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	PowerPowerModeButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POWER_TYPE_POWER_MODE_BUTTON, PowerPowerModeButton);
	switch (property_id) {
		case POWER_POWER_MODE_BUTTON_PPROFILE_PROPERTY:
		power_power_mode_button_set_pprofile (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

